#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
# ***************************************************************************/
_rev = "$Revision: 16 $"[10:-1].strip()
__version__ = "1.2."+_rev
__author__ = "Paul Hardwick <paul@peck.org.uk>"
__date__ =  "$Date: 2009-05-26 23:04:11 +0100 (Tue, 26 May 2009) $"[6:18].strip()

#Program preferences

import pygtk
pygtk.require('2.0')
import gtk
import re

def ErrorDialog(parent, title,msg):
    #display an error
    msgbox = gtk.MessageDialog(parent, buttons = gtk.BUTTONS_OK, flags = gtk.DIALOG_MODAL,
                                type= gtk.MESSAGE_ERROR, message_format = msg)
    msgbox.set_title(title)
    msgbox.run()
    msgbox.destroy()

def validateInteger(number):
    if re.match("^[0-9]+$", number) != None:
        return 1
    return 0

def PrefDialog(window,prog,strings ):
    dialog = gtk.Dialog(title=strings["pref_title"], parent = window,
                        flags = gtk.DIALOG_MODAL | gtk.DIALOG_DESTROY_WITH_PARENT,
                        buttons=(gtk.STOCK_OK, gtk.RESPONSE_ACCEPT))
    pref = {}
    acbutton = gtk.CheckButton(strings['pref_autoconnect'])
    check = 0
    if validateInteger(prog.get('autoconnect','0')):
        check = int(prog.get('autoconnect','0'))
    acbutton.set_active(check)
    
    arcbutton = gtk.CheckButton(strings['pref_autoreconnect'])
    check = 0
    if validateInteger(prog.get('autoreconnect','0')):
        check = int(prog.get('autoreconnect','0'))
    arcbutton.set_active(check)
    
    acdelay = gtk.Entry()
    acdelay.set_max_length(5)
    acdelay.set_width_chars(5)
    acdelay.set_text(prog.get('autoconnectdelay','0'))
    acdelay.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))

    wrbutton = gtk.CheckButton(strings['pref_warn_roaming'])
    check = 0
    if validateInteger(prog.get('warn_roaming','0')):
        check = int(prog.get('warn_roaming','0'))
    wrbutton.set_active(check)
    
    sqwkbut = gtk.CheckButton(strings['pref_show_quick_switch_buttons'])
    check = 0
    if validateInteger(prog.get('show_quick_switch_buttons','0')):
        check = int(prog.get('show_quick_switch_buttons','0'))    
    sqwkbut.set_active(check)
    
    limitbut = gtk.CheckButton(strings['pref_warn_transferlimit'])
    check = 0
    if validateInteger(prog.get('warn_transfer_limit','0')):
        check = int(prog.get('warn_transfer_limit','0'))      
    limitbut.set_active(check)
    
    debugbut = gtk.CheckButton(strings['pref_showdebug'])
    check = 0
    if validateInteger(prog.get('debug','0')):
        check = int(prog.get('debug','0'))         
    debugbut.set_active(check)

    umtsmode = gtk.combo_box_new_text()
    for n in range(4):
        umtsmode.append_text(strings['umts_mode_'+str(n)])
    check = 0
    if validateInteger(prog.get('umts_mode','0'))  and ( prog.get('umts_mode','0') in "0123"):
        check = int(prog.get('umts_mode','0'))  
    umtsmode.set_active(check)
    
    timeout = gtk.Entry()
    timeout.set_max_length(5)
    timeout.set_width_chars(5)
    timeout.set_text(prog.get('connection_timeout','20'))
    timeout.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))
 
    tflimit = gtk.Entry()
    tflimit.set_max_length(5)
    tflimit.set_width_chars(5)
    tflimit.set_text(prog.get('transfer_limit','10'))
    tflimit.connect("activate", lambda *args: dialog.response(gtk.RESPONSE_ACCEPT))


    
#############
# Layout in Table
#############    
    hbox = gtk.Table(18,2)
    hbox.set_col_spacing(0, 0)
    hbox.set_col_spacing(1, 0)
    hbox.attach(wrbutton, 0,1,0,1)

    hbox.attach(limitbut, 0,1,1,2)

    lbl = gtk.Label(strings['pref_transfer_limit'])
    lbl.set_justify(gtk.JUSTIFY_RIGHT)
    hbox.attach(lbl, 0,1,3,4,gtk.EXPAND,gtk.EXPAND)    
    hbox.attach(tflimit, 1,2,3,4)
    
    lbl = gtk.Label(strings['pref_connect_timeout'])
    lbl.set_justify(gtk.JUSTIFY_RIGHT)
    hbox.attach(lbl, 0,1,5,6,gtk.EXPAND,gtk.EXPAND) 
    hbox.attach(timeout, 1,2,5,6)
    
    lbl = gtk.Label(strings['pref_startup_mode'])
    lbl.set_justify(gtk.JUSTIFY_RIGHT )   
    hbox.attach(lbl, 0,1,7,8,gtk.EXPAND,gtk.EXPAND) 
    hbox.attach(umtsmode, 1,2,7,8)    
    hbox.attach(sqwkbut, 0,1,9,10)

    hbox.attach(acbutton, 0,1,11,12)    
    hbox.attach(arcbutton, 0,1,13,14)
    lbl = gtk.Label(strings['pref_autoconnectdelay'])
    lbl.set_justify(gtk.JUSTIFY_RIGHT )   
    hbox.attach(lbl, 0,1,15,16,gtk.EXPAND,gtk.EXPAND)  
    hbox.attach(acdelay, 1,2,15,16) 
    hbox.attach(debugbut, 0,1,17,18)

###
###
    dialog.vbox.pack_start(hbox)
    dialog.show_all()
    response = dialog.run()
    dialog.hide()
    
    if response == gtk.RESPONSE_ACCEPT:
        pref['warn_transfer_limit'] =str((0,1)[ limitbut.get_active()])
        pref['transfer_limit']= tflimit.get_text()
        pref['warn_roaming'] = str((0,1)[ wrbutton.get_active()])
        pref['connection_timeout']= timeout.get_text()
        pref['debug']=  str((0,1)[ debugbut.get_active()])
        pref['show_quick_switch_buttons']= str((0,1)[ sqwkbut.get_active()])
        pref['umts_mode']= str(umtsmode.get_active())
        pref['autoconnect'] =str((0,1)[ acbutton.get_active()])
        pref['autoreconnect'] =str((0,1)[ arcbutton.get_active()])        
        pref['autoconnectdelay']= acdelay.get_text()
        return pref
    else:
        return None

def runPrefDialog(window,prog,strings):
    ans = None
    while True:
        ans = PrefDialog(window,prog,strings)
        if ans == None : return ans #User canceled
        #do some validation
        if (not validateInteger(ans['autoconnectdelay'].strip()) ) or (int(ans['autoconnectdelay'].strip()) <= 9) :
            ErrorDialog(window, strings['error'],strings['error_autoconnectdelay'])
            continue
        if (not validateInteger(ans['transfer_limit'].strip()) ) or (int(ans['transfer_limit'].strip()) <= 0) :
            ErrorDialog(window, strings['error'],strings['error_transfer_limit'])
            continue
        if (not validateInteger(ans['connection_timeout'].strip()) ) or (int(ans['connection_timeout'].strip()) <= 0) :
            ErrorDialog(window, strings['error'],strings['error_connection_timeout'])
            continue
        break
    return ans
    
