#!/usr/bin/env python
#/***************************************************************************
# *   Copyright (C) 2008 by Paul Hardwick                                   *
# *   paul@peck.org.uk                                                      *
# *                                                                         *
# *   This program is free software; you can redistribute it and/or modify  *
# *   it under the terms of the GNU General Public License as published by  *
# *   the Free Software Foundation; either version 2 of the License, or     *
# *   (at your option) any later version.                                   *
# *                                                                         *
# *   This program is distributed in the hope that it will be useful,       *
# *   but WITHOUT ANY WARRANTY; without even the implied warranty of        *
# *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         *
# *   GNU General Public License for more details.                          *
# *                                                                         *
# *   You should have received a copy of the GNU General Public License     *
# *   along with this program; if not, write to the                         *
# *   Free Software Foundation, Inc.,                                       *
# *   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             *
#/***************************************************************************
usage = """Usage: 

python hsocremote.py COMMAND
    COMMAND:  EXIT STATS CONNECT DISCONNECT HIDE SHOW DEBUG
"""

import sys
from traceback import print_exc
import time

import dbus

def main():
    bus = dbus.SessionBus()
    try:
        remote_object = bus.get_object("org.pharscape.HSOconnect.Service","/hsoc")
    except dbus.DBusException:
        print "ERROR: HSOconnect is not running"
        sys.exit(1)
    iface = dbus.Interface(remote_object, "org.pharscape.HSOconnect.Interface")
    # introspection is automatically supported
    if len(sys.argv) == 2:
        if sys.argv[1:] == ['EXIT']:
            iface.Exit()
        elif sys.argv[1:] == ['STATS']:
            res= iface.ReportStats()
            for n in res:
                print n
        elif sys.argv[1:] == ['HIDE']:
            iface.Hide()
        elif sys.argv[1:] == ['SHOW']:
            iface.Show()
        elif sys.argv[1:] == ['CONNECT']:
            iface.Connect()
        elif sys.argv[1:] == ['DISCONNECT']:
            iface.Disconnect()
        elif sys.argv[1:] == ['DEBUG']:
            print usage
            print remote_object.Introspect(dbus_interface="org.freedesktop.DBus.Introspectable")


if __name__ == '__main__':
    main()
